/*
groovix-xserver-inactivity-time

print out in ms how long since keyboard or mouse activity on the xserver

Adapted by Michael Pardee , Open Sense Solutions LLC , for Groovix

Code taken from:
http://ubuntuforums.org/archive/index.php/t-1252752.html
user stroyan

man xscreensaverqueryinfo
apt-get install libxss-dev
Build with:
cc groovix-xserver-inactivity-time.c -o groovix-xserver-inactivity-time -lX11 -lXext -lXss


*/


#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/extensions/scrnsaver.h>

int main(int argc, char *argv[])
{
Display *display;
int event_base, error_base;
XScreenSaverInfo info;
float seconds;

display = XOpenDisplay("");

/*without this check it core dumps if the display can't be opened*/
if ( display == NULL ) {
	fprintf(stderr,"Error: unable to open display\n");
	printf("-1\n");
	return(1);
}

if (XScreenSaverQueryExtension(display, &event_base, &error_base)) {
	XScreenSaverQueryInfo(display, DefaultRootWindow(display), &info);

	/* seconds = (float)info.idle/1000.0f; */
	/* we want ms not seconds */
	seconds = info.idle;
	printf("%.0f\n",seconds);
	return(0);
} else {
	fprintf(stderr,"Error: XScreenSaver Extension not present\n");
	return(1);
}
}
